package log

import (
	"context"
	"github.com/gogf/gf/os/glog"
)

type MyWriter struct {
	logger *glog.Logger
}

func init() {
	glog.SetWriter(&MyWriter{
		logger: glog.New(),
	})
}

func (w *MyWriter) Write(p []byte) (n int, err error) {
	//s := string(p)
	//if gregex.IsMatchString(`PANI|FATA|ERRO`, s) {
	//	fmt.Println("SERIOUS ISSUE OCCURRED!! I'd better tell monitor in first time!")
	//	//ghttp.PostContent("http://monitor.mydomain.com", s)
	//}
	return w.logger.Write(p)
}

type Log struct {
	Url         string      `json:"Url,omitempty"` //请求路径
	Method      string      `json:"Method,omitempty"`
	Request     interface{} `json:"Request,omitempty"`     //请求参数
	Respone     interface{} `json:"Respone,omitempty"`     //响应参数
	ResponeTime interface{} `json:"ResponeTime,omitempty"` //响应时间
	Error       error       `json:"Error,omitempty"`       //错误
	Ext         interface{} `json:"Ext,omitempty"`         //扩展字段
}

func Info(ctx context.Context, cat string, params *Log) {
	glog.Ctx(ctx).Cat(cat).Info(params)
}

func Error(ctx context.Context, cat string, params *Log) {
	glog.Ctx(ctx).Cat(cat).Error(params)
}
